PROGRAM fileHANDLEr;

USES Crt,Dos;

Type MSGTOIDXrecord = String[35];
     FlagType       = array[1..4] of Byte;
     Time           = String[5];
     Date           = String[8];
     COMBINEDrecord = array[1..200] of Word;
     AskType        = (Yes, No, Ask, Only);
  VideoType      = (Auto, Short, Long);
  MsgType        = (LocalMail, NetMail, EchoMail, Internet, Newsgroup);
  MsgKindsType   = (Both, Private, Public, ROnly, NoReply);
  OrphanType     = (Ignore, Create, Kill);
  ResetType      = (Never, Week, Month, Year);
  LongDate       = String[9];
  ByteArray32    = Array[1..32] of Byte;

  ARCrecord = record
                Extension : String[3];
                UnpackCmd,
                PackCmd   : String[60];
              end;




   NetAddress     = record
                     Zone,
                     Net,
                     Node,
                     Point          : Word;
                   end;

  USERSrecord    = record
                     Name           : MSGTOIDXrecord;
                     Location       : String[25];
                     Organisation,
                     Address1,
                     Address2,
                     Address3       : String[50];
                     Handle         : String[35];
                     Comment        : String[80];
                     PasswordCRC    : LongInt;
                     DataPhone,
                     VoicePhone     : String[15];
                     LastTime       : Time;
                     LastDate       : Date;

                     Attribute,

                      { Bit 0 : Deleted
                            1 : Clear screen
                            2 : More prompt
                            3 : ANSI
                            4 : No-kill
                            5 : Xfer priority
                            6 : Full screen msg editor
                            7 : Quiet mode }

                     Attribute2     : Byte;

                      { Bit 0 : Hot-keys
                            1 : AVT/0
                            2 : Full screen message viewer
                            3 : Hidden from userlist
                            4 : Page priority
                            5 : No echomail in mailbox scan
                            6 : Guest account
                            7 : Post bill enabled }

                     Flags          : FlagType;
                     Credit,
                     Pending        : LongInt;
                     MsgsPosted,
                     Security       : Word;
                     LastRead,
                     NoCalls,
                     Uploads,
                     Downloads,
                     UploadsK,
                     DownloadsK,
                     TodayK         : LongInt;
                     Elapsed        : Integer;
                     ScreenLength   : Word;
                     LastPwdChange  : Byte;
                     Group          : Word;
                     CombinedInfo   : COMBINEDrecord;
                     FirstDate,
                     BirthDate,
                     SubDate        : Date;
                     ScreenWidth,
                     Language,
                     DateFormat     : Byte;      
                     ForwardTo      : String[35];
                     MsgArea,
                     FileArea       : Word;
                     DefaultProtocol: Char;
                     FileGroup      : Word;
                     LastDOBCheck   : Byte;
                     Sex            : Byte;
                     XIrecord       : LongInt;
                     MsgGroup       : Word;

                     Attribute3     : Byte;

                      { Bit 0 : Mailbox check: scan selected areas only }

                     Password       : String[15];

                     FreeSpace      : Array[1..31] of Byte;
                   end;

  FILESHDRrecord = record
                     Name           : String[12];
                     Size,
                     CRC32          : LongInt;
                     Uploader       : String[35];
                     UploadDate,
                     FileDate,
                     LastDL         : LongInt;
                     TimesDL        : Word;
                     Attrib         : Byte;
                     Password       : String[15];
                     KeyWord        : Array[1..5] of String[15];
                     Cost           : Word;
                     LongDescPtr    : LongInt;
                     FreeSpace      : Array[1..20] of Byte;
                   end;

  RACONFIGrecord = record
    VersionID           : Word;
    xCommPort           : Byte;
    xBaud               : LongInt;
    xInitTries          : Byte;
    xInitStr,
    xBusyStr            : String[70];
    xInitResp,
    xBusyResp,
    xConnect300,
    xConnect1200,
    xConnect2400,
    xConnect4800,
    xConnect9600,
    xConnect19k,
    xConnect38k         : String[40];
    xAnswerPhone        : Boolean;
    xRing,
    xAnswerStr          : String[20];
    xFlushBuffer        : Boolean;
    xModemDelay         : Integer;

    MinimumBaud,
    GraphicsBaud,
    TransferBaud        : word;
    SlowBaudTimeStart,
    SlowBaudTimeEnd,
    DownloadTimeStart,
    DownloadTimeEnd     : Time;

    PageStart           : Array[0..6] of Time;
    PageEnd             : Array[0..6] of Time;

    SeriNum,
    CustNum             : String[22];
{}  FreeSpace1          : Array[1..24] of Byte;
    PwdExpiry           : Word;

    MenuPath,
    TextPath,
    AttachPath,
    NodelistPath,
    MsgBasePath,
    SysPath,
    ExternalEdCmd       : String[60];

    Address             : Array[0..9] of NetAddress;
    SystemName          : String[30];

    NewSecurity         : Word;
    NewCredit           : Word;
    NewFlags            : FlagType;

    OriginLine          : String[60];
    QuoteString         : String[15];
    Sysop               : String[35];
    LogFileName         : String[60];
    FastLogon,
    AllowSysRem,
    MonoMode,
    StrictPwdChecking,
    DirectWrite,
    SnowCheck           : Boolean;
    CreditFactor        : Integer;

    UserTimeOut,
    LogonTime,
    PasswordTries,
    MaxPage,
    PageLength          : Word;
    CheckForMultiLogon,
    ExcludeSysopFromList,
    OneWordNames        : Boolean;
    CheckMail           : AskType;
    AskVoicePhone,
    AskDataPhone,
    DoFullMailCheck,
    AllowFileShells,
    FixUploadDates,
    FreezeChat          : Boolean;
    ANSI,                       { ANSI: Yes, no, or ask new users     }
    ClearScreen,                { Clear:        "                     }
    MorePrompt          : AskType;    { More:         "                     }
    UploadMsgs          : Boolean;
    KillSent            : AskType;    { Kill/Sent     "                     }

    CrashAskSec         : Word;       { Min sec# to ask 'Crash Mail ?'      }
    CrashAskFlags       : FlagType;
    CrashSec            : Word;       { Min sec# to always send crash mail. }
    CrashFlags          : FlagType;
    FAttachSec          : Word;       {        "    ask 'File Attach ?'     }
    FAttachFlags        : FlagType;

    NormFore,
    NormBack,
    StatFore,
    StatBack,
    HiBack,
    HiFore,
    WindFore,
    WindBack,
    ExitLocal,
    Exit300,
    Exit1200,
    Exit2400,
    Exit4800,
    Exit9600,
    Exit19k,
    Exit38k             : Byte;

    MultiLine           : Boolean;
    MinPwdLen           : Byte;
    MinUpSpace          : Word;
    HotKeys             : AskType;
    BorderFore,
    BorderBack,
    BarFore,
    BarBack,
    LogStyle,
    MultiTasker,
    PwdBoard            : Byte;
    xBufferSize         : Word;
    FKeys               : Array[1..10] of String[60];

    WhyPage             : Boolean;
    LeaveMsg            : Byte;
    ShowMissingFiles,
    xLockModem          : Boolean;
{}  FreeSpace2          : Array[1..10] of Byte;
    AllowNetmailReplies : Boolean;
    LogonPrompt         : String[40];
    CheckNewFiles       : AskType;
    ReplyHeader         : String[60];
    BlankSecs           : byte;
    ProtocolAttrib      : Array[1..6] of Byte;
    xErrorFreeString    : String[15];
    xDefaultCombined    : array[1..25] of Byte;
    RenumThreshold      : Word;
    LeftBracket,
    RightBracket        : Char;
    AskForHandle        : Boolean;
    AskForBirthDate     : Boolean;

    GroupMailSec        : Word;

    ConfirmMsgDeletes   : Boolean;

    FreeSpace4          : Array[1..30] of byte;

    TempScanDir         : String[60];
    ScanNow             : AskType;
    xUnknownArcAction,
    xFailedUnpackAction,
    FailedScanAction    : Byte; {Bit 0:Mark deleted, 1:Mark unlisted, 2:Mark notavail}
    xUnknownArcArea,
    xFailedUnpackArea,
    FailedScanArea      : Word;
    ScanCmd             : String[60];
    xDeductIfUnknown    : Boolean;

    NewUserGroup        : Byte;
    AVATAR              : AskType;
    BadPwdArea          : Byte;
    Location            : String[40];
    DoAfterAction       : Byte; {0 = wait for CR, > 0 = wait for x seconds}
{}  OldFileLine         : String[40];
    CRfore,
    CRback              : Byte;
    LangHdr             : String[40];
    xSendBreak          : Boolean;
{}  ListPath            : String[60];
    FullMsgView         : AskType;
    EMSI_Enable         : AskType;
    EMSI_NewUser        : Boolean;

    EchoChar            : String[1];
    xConnect7200,
    xConnect12000,
    xConnect14400       : String[40];
    Exit7200,
    Exit12000,
    Exit14400           : Byte;
    ChatCommand         : String[60];
    ExtEd               : AskType;
    NewuserLanguage     : Byte;
    LanguagePrompt      : String[40];
    VideoMode           : VideoType;
    AutoDetectANSI      : Boolean;
    xOffHook            : Boolean;
    NewUserDateFormat   : Byte;
    KeyboardPwd         : String[15];
    CapLocation         : Boolean;
    NewuserSub          : Byte;
    PrinterName         : String[4];
    HilitePromptFore,
    HiLitePromptBack    : Byte;
    xInitStr2           : String[70];
    AltJSwap            : Boolean;
    SemPath             : String[60];
    AutoChatCapture     : Boolean;

    FileBasePath        : String[60];
    NewFileTag          : Boolean;
    IgnoreDupeExt       : Boolean;
    TempCDFilePath      : String[60];
    TagFore,
    TagBack             : Byte;
    xConnect16k         : String[40];
    Exit16k,
    FilePayback         : Byte;
    FileLine,
    FileMissingLine     : String[200];
    NewUserULCredit     : Byte;
    NewUserULCreditK    : Word;
    ArcInfo             : Array[1..10] of ARCrecord;
    RAMGRAltFKeys       : Array[1..5] of String[60];
    ArcViewCmd          : String[60];
    xConnectFax         : String[40];
    ExitFax             : Byte;
    UseXMS,
    UseEMS              : Boolean;
    CheckDOB            : Byte;
    EchoCheck           : AskType;
    ccSec,
    ReturnRecSec        : Word;
    HonourNetReq        : Boolean;
    DefaultCombined     : COMBINEDrecord;
    AskForSex,
    AskForAddress       : Boolean;
    DLdesc              : AskType;
    NewPhoneScan        : Boolean;

    Exit21k,
    Exit24k,
    Exit26k,
    Exit28k,
    Exit57k,
    Exit64k             : Byte;

    TagLogoffWarning,
    LimitLocal,
    SavePasswords       : Boolean;

    BlankLogins         : Byte;
    ripiconpath         : string[60];

    Exit31k,
    Exit33k             : Byte;
    IncludeNewCDareas   : Boolean;

    FutureExpansion : Array[1..513] of Byte;
  end;

FUNCTION PATH2R2H:string;

VAR path2,path:string;

BEGIN
path2:=paramstr(0);
repeat
delete(path2,1,(pos('\',path2)));
until pos('\',path2)=0;
path:=paramstr(0);
delete(path,pos(path2,paramstr(0)),20);
path2r2h:=path;
END;

FUNCTION PATH2CFG:string;

VAR c: file of raconfigrecord;
     cfg: raconfigrecord;

   BEGIN
   assign(c,getenv('ra')+'\config.ra');
   {$I-}
   reset(c);
   {$I+}
   if ioresult<>0 then
      BEGIN
      writeln('# RA-Configfile could not been read');
      writeln('# check: ',getenv('ra'),'\config.ra');
      halt(1);
      END;
   read(c,cfg);
   close(c);
   path2cfg:=cfg.msgbasepath;
   END;

FUNCTION PATH2hdr:string;

VAR c: file of raconfigrecord;
     cfg: raconfigrecord;

   BEGIN
   assign(c,getenv('ra')+'\config.ra');
   {$I-}
   reset(c);
   {$I+}
   if ioresult<>0 then
      BEGIN
      writeln('# RA-Configfile could not been read');
      writeln('# check: ',getenv('ra'),'\config.ra');
      halt(1);
      END;
   read(c,cfg);
   close(c);
   path2hdr:=cfg.filebasepath;
   END;

TYPE userrecord = record
              name: string[35];
              handle: string[20]
              end;

PROCEDURE header;
BEGIN
   gotoxy(1,1);
   writeln('REAL2HANDLE - filebase kewlizer - Version 0.992');
   writeln('');
END;

PROCEDURE clear;
VAR a:byte;
BEGIN
   for a:=3 to 20 do writeln('                                                                               ');
END;

VAR convert:array[1..300] of userrecord;
    converta:byte;
    index:byte;


PROCEDURE CHDR(number:byte);

VAR g:file of fileshdrrecord;
    hdr:fileshdrrecord;
    namec:string;
    n:byte;
    b:byte;
    found:boolean;
    filenumber:string;
    y:byte;

BEGIN
str(number,filenumber);
assign(g,path2hdr+'\hdr\fdb'+filenumber+'.hdr');
{$I-}
reset(g);
{$I+}
if (ioresult<>0) or (filesize(g)=0) then
   BEGIN
   if (ioresult<>0) and (filesize(g)=0) then close(g);
   END
  else
   BEGIN
   if index=9 then index:=0;
   if index=0 then
      BEGIN
      header;
      clear;
      gotoxy(1,21);
      writeln('');
      END;
   y:=3+(index*2);
   gotoxy(1,(y));
   writeln('[]  []');
   gotoxy(2,y);
   write(number);
   gotoxy(9,y);
   write(filesize(g));
   gotoxy(16,y);
   write('[');
   for n:=0 to (filesize(g)-1) do if n mod 10 = 0 then write('');
   write('] '{,getpath,'\hdr\fdb',filenumber,'.hdr'});
   gotoxy(13,y);
   for n:=0 to (filesize(g)-1) do
    BEGIN
    if n mod 10 = 0 then
       BEGIN
       gotoxy((17+(n div 10)),y);
       write ('');
       END;
    seek(g,n);
    read (g,hdr);
    gotoxy(1,(y+1));
    write('               [.] [] []');
    gotoxy(17,(y+1));
    write(hdr.name);
    gotoxy(32,(y+1));
    write(hdr.uploader);
    found:=false;
    b:=0;
    repeat
        BEGIN
        b:=b+1;
        if hdr.uploader=convert[b].name then
           BEGIN
           hdr.uploader:=convert[b].handle;
           found:=true;
           END;
        END;
    until (found=true) or (b=converta);
    gotoxy(57,(y+1));
    write(hdr.uploader);
{    delay(30);}
    seek (g,n);
    write (g,hdr);
    END;
   close(g);
   writeln;
   index:=index+1;
   END;
END;

PROCEDURE readuser;
VAR f:file of usersrecord;
    g: text;
    user:usersrecord;
    b,code:integer;
    text:string;
    a:byte;

   BEGIN
   assign(g,path2r2h+'r2handle.cfg');
   {$I-}
   reset(g);
   {$I+}
   if ioresult<>0 then
      BEGIN
      header;
      writeln;
      writeln('CONFiGFILE DOES NOT EXiST!');
      writeln('CHECK ',path2r2h,'r2handle.cfg');
      halt(4);
      END;
   readln(g,text);
   val(text,b,code);
   if code<>0 then
      BEGIN
      header;
      writeln;
      writeln('ERROR iN CONFiGFiLE!');
      halt(5);
      END;
   for code:=1 to b do
       BEGIN
       readln(g,convert[code].name);
       readln(g,convert[code].handle);
       if b=299 then exit;
       END;
   close(g);
   a:=b;
   assign(f,path2cfg+'\users.bbs');
   reset(f);
   repeat
      a:=a+1;
      read(f,user);
      convert[a].name:=user.name;
      convert[a].handle:=user.handle;
      if b=299 then exit;
   until eof(f);
   close(f);
   converta:=a;
   END;

VAR i:byte;
    error:integer;
    anfang,ende:byte;

BEGIN
index:=0;
readuser;
if paramcount=0 then
   BEGIN
   header;
   writeln;
   writeln('NO AREAS GIVEN AS PARAMETERS!');
   halt(2);
   END;
val(paramstr(1),anfang,error);
if error<>0 then
   BEGIN
   header;
   writeln;
   writeln('PARAMETERS GIVEN REPRESENT NO AREAS!');
   halt(3);
   END;
if paramcount=1 then
   BEGIN
   ende:=anfang;
   END
  else
   BEGIN
   val(paramstr(2),ende,error);
   if error<>0 then
      BEGIN
      header;
      writeln;
      writeln('PARAMETERS GIVEN REPRESENT NO AREAS!');
      END;
   END;
if anfang > ende then
   BEGIN
   i:=anfang;
   anfang:=ende;
   ende:=i;
   END;
gotoxy(78-((ende-anfang) div 10),22); write('[');
gotoxy(79-((ende-anfang) div 10),22);
for i:=1 to ((ende-anfang) div 10) do
    BEGIN
    write('');
    END;
gotoxy(79,22); write(']');
for i:=anfang to ende do
    BEGIN
    chdr(i);
    gotoxy((79-(ende-anfang) div 10),22);
    for error:=1 to ((i-anfang) div 10) do
        BEGIN
        write('');
        END;
    END;
    gotoxy(1,23);
END.